(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/common'], factory) :
	(factory((global['text-show-more-less'] = {}),global.core,global.common));
}(this, (function (exports,core,common) { 'use strict';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var TextShowLessComponent = (function () {
    function TextShowLessComponent() {
        this.showTail = false;
        // @Input() textData;
        this.data = '';
        //data = 'Mufthi Mohammed Ali'
        this.tempLength = 0;
        this.readMore = false;
        this.showMoreText = '+ Read More';
        this.showLessText = '- Read Less';
    }
    /**
     * @return {?}
     */
    TextShowLessComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.tempLength = this.data.length;
        this.maxLengthCloned = this.maxLength || 0;
        this.data = this.data || '';
    };
    /**
     * @param {?} data
     * @return {?}
     */
    TextShowLessComponent.prototype.swap = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        // console.log('read more..readless fired'+ this.data.length);
        // console.log('tempLength ' + this.tempLength);
        // console.log('maxLengthCloned ' + this.maxLengthCloned);
        // console.log('maxLength' + this.maxLength);
        // this.tempLength =  this.data.length + this.maxLengthCloned;
        // this.maxLengthCloned =  this.data.length - this.maxLengthCloned;
        // this.tempLength =  this.data.length - this.maxLengthCloned;
        if (this.maxLengthCloned === this.maxLength) {
            this.maxLengthCloned = this.data.length;
        }
        else {
            this.maxLengthCloned = this.maxLength;
        }
        // console.log('tempLength ' + this.tempLength);
        // console.log('maxLengthCloned ' + this.maxLengthCloned);
        // console.log('maxLength' + this.maxLength);
        // this.readMore = data;
    };
    TextShowLessComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'crystal-text-show-less',
                    template: "<div class=\"text-show-less\" style=\"text-align: justify;\"> <div *ngIf=\"maxLength < data?.length\">   <div *ngIf=\"maxLengthCloned < data?.length\"  > <!-- {{maxLengthCloned}} - {{data?.length}} - {{maxLength}} --> {{ (data  | slice: 0:maxLength) + '...' }}  <div *ngIf=\"showTail\" class=\"custom-end d-inline-block custom-font-size\" style=\"position: relative;\" (click)=\"swap('show more')\"> {{showMoreText}} </div> <!-- {{data.length}} --> </div> <div *ngIf=\"maxLengthCloned >= data?.length\"> {{ data  }}  <div *ngIf=\"maxLengthCloned >= data?.length && showTail\" style=\"position: relative;\" class=\"custom-end d-inline-block custom-font-size\" (click)=\"swap('show less')\"> {{showLessText}}</div>  </div> </div> <div *ngIf=\"maxLength >= data?.length\"  >{{ data }}  </div> </div> <!-- <div class=\"truncate\" [ngClass]=\"{'truncated':readMore}\"> {{data}} <div *ngIf=\"!readMore\" class=\"custom-end d-inline-block custom-font-size\" (click)=\"swap(true)\"> {{showMoreText}} </div> <div *ngIf=\"readMore\" class=\"custom-end d-inline-block custom-font-size\" (click)=\"swap(false)\"> {{showLessText}} </div> </div> --> ",
                    styles: [".custom-end { color: #007bff; text-decoration: none; -ms-touch-action: manipulation; touch-action: manipulation; background-color: transparent; cursor: pointer; } div { line-height: 1.3; font-size: 13px; } .d-inline-block { display: inline-block; } .custom-font-size { font-size: 12px; } .truncate { white-space: nowrap; overflow: hidden; text-overflow: ellipsis; float: left; word-wrap: break-word; width: 300px; } .truncate.truncated { white-space: initial; } .form-control:focus { border-color: transparent; } "]
                },] },
    ];
    /** @nocollapse */
    TextShowLessComponent.ctorParameters = function () { return []; };
    TextShowLessComponent.propDecorators = {
        "maxLength": [{ type: core.Input },],
        "showTail": [{ type: core.Input },],
        "data": [{ type: core.Input },],
    };
    return TextShowLessComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var TextShowMoreLessModule = (function () {
    function TextShowMoreLessModule() {
    }
    /**
     * @return {?}
     */
    TextShowMoreLessModule.forRoot = /**
     * @return {?}
     */
    function () {
        return {
            ngModule: TextShowMoreLessModule,
            providers: []
        };
    };
    TextShowMoreLessModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule
                    ],
                    declarations: [
                        TextShowLessComponent,
                    ],
                    exports: [
                        TextShowLessComponent,
                    ]
                },] },
    ];
    return TextShowMoreLessModule;
}());

exports.TextShowMoreLessModule = TextShowMoreLessModule;
exports.TextShowLessComponent = TextShowLessComponent;

Object.defineProperty(exports, '__esModule', { value: true });

})));
